{*******************************************}
{* Niektor sieov funkcie Novell NetWare *}
{* Vpis prihlsench, posielanie sprv,...*}
{* (c) tefan Stieranka                    *}
{*******************************************}

Program NetTools;

uses Dos;

const
  Hex: Array[0..15] of Char = '0123456789ABCDEF';

var
  Station, UserMax, Result: Integer;
  ServerName, OSName, SUserName, SMessage: String;
  Func: Byte;

Function FStr(Str: String; Len: Integer; Ch: Char): String;
{ formtuje textov reazec na uren dku urenm znakom }
begin
  If Len > 0 then
  begin                                                  { formtuje vpravo }
    While Length(Str) < Len do Str := Str + Ch;
    If Length(Str) > Len then Str := Copy(Str,1,Len);
  end else
  begin                                                   { formtuje vavo }
    Len := Abs(Len);
    While Length(Str) < Len do Str := Ch + Str;
    If Length(Str) > Len then Str := Copy(Str,Length(Str)-Len,Len);
  end;
  FStr := Str;
end;

Procedure GetConection(var Station: Integer);
{ zist slo pripojenia k sieti }
var
  Reg: Registers;

begin
  Reg.AH := $DC;                                       { CDh - slo sluby }
  MsDos(Reg);
  Station := Reg.AL;     { AL - slo pripojenia k sieti (0 = nepripojenie) }
end;

Procedure GetConnectionInfo(var StationNum: Integer; var Name: String;
  var HexId: String; var ConType: Integer; var DatTim: String;
                                                      var Result: Integer);
{ zist infirmcie o stanici pripojenej k sieti poda sla stanice }
type
  TInpBuf = record
    LenBuf: Integer;                                { dka vstupnho bufru }
    FuncNum: Byte;                                                { funkcia }
    ConnectionNum: Byte;                                 { slo pripojenia }
  end;
  TOutBuf = record
    LenBuf: Integer;                               { dka vstupnho bufru }
    Id1: Array[1..2] of Byte;                 { identifikan slo objektu }
    Id2: Array[1..2] of Byte;                 { identifikan slo objektu }
    ConnType: Array[1..2] of Byte;                            { typ objektu }
    ObjectName: Array[1..48] of Byte;                        { meno objektu }
    LoginTime: Array[1..8] of Byte;       { dtum a as prihlsenia na sie }
  end;
var
  InpBuf: TInpBuf;
  OutBuf: TOutBuf;
  Reg: Registers;
  I,X: Integer;
  Year,Month,Day,Hour,Minute: String;
begin
  With InpBuf do
  begin
    LenBuf := 2;
    FuncNum := $16;           { 16h - zisti informcie o pripojenom objekte }
    ConnectionNum := StationNum;
  end;
  OutBuf.LenBuf := 62;
  Reg.AH := $E3;                                             { slo sluby }
  Reg.DS := Seg(InpBuf);
  Reg.SI := Ofs(InpBuf);
  Reg.ES := Seg(OutBuf);
  Reg.DI := Ofs(OutBuf);
  MsDos(Reg);
  Result := Reg.AL;                       { vsledn kd volania preruenia }
  Name := '';
  HexId := '';
  ConType := 0;
  DatTim := '';
  If Result = 0 then                               { ak je vetko bez chyby }
  begin
    With OutBuf do
    begin
      I := 1;
      While (I <= 48)  and (ObjectName[I] <> 0) do     { zisti meno objektu }
      begin
        Name[I] := Chr(ObjectName[I]); Inc(I);
      end;
      Name[0] := Chr(I - 1);                      { uri dku reazca mena }
      If Name <> '' then
      begin                              { formtuj dtum a as prihlsenia }
        Str(LoginTime[1],Year); Str(LoginTime[2],Month);
        Str(LoginTime[3],Day); Str(LoginTime[4],Hour);
        Str(LoginTime[5],Minute);
        DatTim := FStr(Day,-2,'0')+'.'+FStr(Month,-2,'0')+'.'+
          Year+'  '+FStr(Hour,-2,'0')+':'+FStr(Minute,-2,'0');
      end;
    end;
  end;
  If Name <> '' then
  begin                              { formtuj identifikan slo objektu }
    HexId := '';        { vsledn reazec uruje meno adresra v SYS:MAIL\ }
    HexId := Hex[OutBuf.Id1[1] shr 4];
    HexId := HexId + Hex[OutBuf.Id1[1] and $0F];
    HexId := HexId + Hex[OutBuf.Id1[2] shr 4];
    HexId := HexId + Hex[OutBuf.Id1[2] and $0F];
    HexId := HexId + Hex[OutBuf.Id2[1] shr 4];
    HexId := HexId + Hex[OutBuf.Id2[1] and $0F];
    HexId := HexId + Hex[OutBuf.Id2[2] shr 4];
    HexId := HexId + Hex[OutBuf.Id2[2] and $0F];
    ConType := OutBuf.ConnType[2];
    While (HexId[1] = '0') and (HexId <> '') do
      HexId := Copy(HexId,2,Length(HexId));
  end;
end;

Procedure GetRealName(var UserName, RealName: String; var Result: Integer);
{ zist relne meno uvaea poda jeho UserName }
type
  TInpBuf = record
    LenBuf: Array[1..2] of Byte;                     { dka vsupnho bufru }
    FuncNum: Byte;                                          { slo funkcie }
    ObjectType: Array[1..2] of Byte;   { typ objektu (uvae,skupina,...) }
    ObjectLen: Byte;                                   { dka mena objektu }
    ObjectName: Array[1..47] of Byte;                        { meno objektu }
    Segment: Byte;                                     { segment vlastnosti }
    PropertyLen: Byte;                              { dka mena vlastnosti }
    PropertyName: Array[1..14] of Byte;                   { meno vlastnosti }
  end;
  TOutBuf = record
    LenBuf: Array[1..2] of Byte;                    { dka vsupnho bufru }
    RealNameA: Array[1..128] of Byte;             { skuton meno uvaea }
    MoreSegments: Byte;                   { slo alieho segmentu (ak je) }
    PropertyFlags: Byte;                                { vlajka vlastnosti }
  end;

var
  InpBuf: TInpBuf;
  OutBuf: TOutBuf;
  I: Integer;
  Id: String;
  Reg: Registers;

begin
  Id := 'IDENTIFICATION';                       { vlastnos - identifikcia }
  With InpBuf do
  begin
    LenBuf[2] := 0;
    LenBuf[1] := 69;
    FuncNum  := $3D;                       { 3Dh - zisti hodnotu vlastnosti }
    ObjectType[1]:= $00;
    ObjectType[2]:= $01;                                 { 0001h - uvae }
    Segment := 1;             { prv segment - identifikcia(skuton meno) }
    ObjectLen := 47;
    PropertyLen := Length(Id);
    FillChar(ObjectName, SizeOf(ObjectName), $0);
    For I := 1 to Length(UserName) do ObjectName[I] := Ord(UserName[I]);
    FillChar(PropertyName, SizeOf(PropertyName), $0);
    For I := 1 to Length(Id) do PropertyName[I] := Ord(Id[I]);
  end;
  With OutBuf do
  begin
    LenBuf[1] := 130;
    LenBuf[2] := 0;
    FillChar(RealNameA, SizeOf(RealNameA), $0);
    MoreSegments := 1;
    PropertyFlags := 0;
  end;
  Reg.AH := $E3;                                             { slo sluby }
  Reg.DS := Seg(InpBuf);
  Reg.SI := Ofs(InpBuf);
  Reg.ES := Seg(OutBuf);
  Reg.DI := Ofs(OutBuf);
  MsDos(Reg);                    { volanie sluby dosu - preruenie INT 21H }
  Result := Reg.AL;                           { vsledok volania preruenia }
  RealName := ''; I := 1;
  While ((I < 128) and (OutBuf.RealNameA[I] <> 0)) do       { skuton meno }
  begin
    RealName := RealName + Chr(OutBuf.RealNameA[I]); Inc(I);
  end;
end;

Procedure GetInternetAddress(Station: Integer; var NetNumber, NodeAddr,
                                  SocketNumber: String; var Result: Integer);
{ zist adresu v Internete (adresa servera + adresa stanice) }
type
  TInpBuf = record
    LenBuf: Integer;                                { dka vstupnho bufru }
    FuncNum: Byte;                                          { slo funkcie }
    Connection: Byte;                                      { slo spojenia }
  end;
  TOutBuf = record
    LenBuf: Integer;                               { dka vstupnho bufru }
    Network: Array[1..4] of Byte;                           { slo serveru }
    Node: Array[1..6] of Byte;                  { adresa pripojenej stanice }
    Socket: Array[1..2] of Byte;  { slo socketu (komunikcia zo serverom) }
  end;

var
  InpBuf: TInpBuf;
  OutBuf: TOutBuf;
  Reg: Registers;
  I: Integer;

begin
  With InpBuf do
  begin
    LenBuf := 2;
    FuncNum := $13;                        { 13h - zisti adresu v internete }
    Connection := Station;
  end;
  FillChar(OutBuf, SizeOf(OutBuf), $0);          { vyprzdni vstupn bufer }
  OutBuf.LenBuf := 12;
  Reg.AH := $E3;                                             { slo sluby }
  Reg.DS := Seg(InpBuf);
  Reg.SI := Ofs(InpBuf);
  Reg.ES := Seg(OutBuf);
  Reg.DI := Ofs(OutBuf);
  MsDos(Reg);
  Result := Reg.AL;                                  { vsledn kd volania }
  NetNumber := ''; NodeAddr := ''; SocketNumber := '';
  if Result = 0 then
  begin
    For I := 1 to 4 do begin                       { formtuj slo serveru }
      NetNumber := NetNumber + Hex[(OutBuf.Network[I] shr 4)];
      NetNumber := NetNumber + Hex[(OutBuf.Network[I] and $0F)];
    end;
    For I := 1 to 6 do begin                      { formtuj adresu stanice }
      NodeAddr := NodeAddr + Hex[(OutBuf.Node[I] shr 4)];
      NodeAddr := NodeAddr + Hex[(OutBuf.Node[I] and $0F)];
    end;
    For I := 1 to 2 do begin                       { formtuj slo socketu }
      SocketNumber := SocketNumber + Hex[(OutBuf.Socket[I] shr 4)];
      SocketNumber := SocketNumber + Hex[(OutBuf.Socket[I] and $0F)];
    end;
  end;
end;

Procedure GetOSInfo(var Info: String);
{ zisuje informcie o operanom systme serveru - verzia ,max.user, (c) }
type
  TInpBuf = record
    LenBuf: Integer;                                { dka vstupnho bufru }
    FuncNum: Byte;                                                { funkcia }
  end;
  TOutBuf = record
    LenBuf: Integer;                               { dka vstupnho bufru }
    Inf: Array[1..512] of Byte;            { informcie o operanom systme }
  end;

var
  InpBuf: TInpBuf;
  OutBuf: TOutBuf;
  Reg: Registers;
  I: Integer;

begin
  With InpBuf do
  begin
    LenBuf := 1;
    FuncNum := $C9;                     { C9h - informcie o nerzii NetWare }
  end;
  With OutBuf do
  begin
    LenBuf := 512;
    FillChar(Inf, SizeOf(Inf), $0);
  end;
  Reg.AH := $E3;                                             { slo sluby }
  Reg.DS := Seg(InpBuf);
  Reg.SI := Ofs(InpBuf);
  Reg.ES := Seg(OutBuf);
  Reg.DI := Ofs(OutBuf);
  MsDos(Reg);
  Info := '';
  For I := 1 to 256 do Info := Info + Chr(OutBuf.Inf[I]);      { informcie }
end;

Procedure GetServerInfo(var SName: String; var UserMax: Integer);
{ zisuje informcie o serveri - meno,max.user }
type
  TInpBuf = record
    LenBuf: Integer;                                { dka vstupnho bufru }
    FuncNum: Byte;                                                { funkcia }
  end;
  TOutBuf = record
    LenBuf: Integer;                               { dka vstupnho bufru }
    ServerN: Array[1..48] of Byte;                           { meno servera }
    NetVers: Byte;                            { verzia NetWare (prv slo) }
    NetSubVers: Byte;                        { verzia NetWare (druh slo) }
    MaxUser: Array[1..2] of Byte;              { maximlny poet uvateov }
    Res: Array[1..75] of Byte;       { rzne informcie (poet prip.stanc, }
  end;                                         { prihlsench uvaeov,...}

var
  InpBuf: TInpBuf;
  OutBuf: TOutBuf;
  Reg: Registers;
  I: Integer;

begin
  With InpBuf do
  begin
    LenBuf := 1;
    FuncNum := 17;                       { 17h - zisti informcie o serveri }
  end;
  OutBuf.LenBuf := 128;
  Reg.AH := $E3;                                             { slo sluby }
  Reg.DS := Seg(InpBuf);
  Reg.SI := Ofs(InpBuf);
  Reg.ES := Seg(OutBuf);
  Reg.DI := Ofs(OutBuf);
  MsDos(Reg);
  With OutBuf do
  begin
    UserMax := (MaxUser[1] * 256) + MaxUser[2];     { max. poet uvaeov }
    SName := '';
    I := 1;
    While ((ServerN[i] <> 0) and (I <> 48)) do               { meno servera }
    begin
      SName := SName + Chr(ServerN[I]);
      Inc(I);
    end;
  end;
end;

Procedure SendMessageToStation(Station: Integer; Message: String;
                                                        var Result: Integer);
{ posiela sprvu uzivatelovi podla stanice prihlsenia }
type
  TInpBuf = record
    LenBuf: Integer;                                { dka vstupnho bufru }
    FuncNum: Byte;                                          { slo funkcie }
    Count: Byte;                                             { poet stanc }
    List: Byte;                                             { slo stanice }
    MsgLength: Byte;                                         { dka sprvy }
    Msg: Array[1..55] of Byte;                                     { sprva }
  end;
  TOutBuf = record
    LenBuf: Integer;                               { dka vstupnho bufru }
    Count: Byte;                                                    { poet }
    List: Byte;                            { vsledn kd zasielania sprvy }
  end;

var
  InpBuf: TInpBuf;
  OutBuf: TOutBuf;
  Reg: Registers;
  I: Integer;

begin
  If Length(Message) > 55 then Message := Copy(Message,1,55);
  With InpBuf do
  begin
    LenBuf := 59;
    FuncNum := $00;                                    { 00h - poli sprvu }
    Count := 1;
    List := Station;
    FillChar(Msg, SizeOf(Msg), $0);
    MsgLength := Length(Message);                            { dka sprvy }
    For I := 1 to Length(Message) do Msg[I] := Ord(Message[I]);
  end;
  With OutBuf do
  begin
    LenBuf := 2; Count := 1; List := 0;
  end;
  Reg.AH := $E1;                                             { slo sluby }
  Reg.DS := Seg(InpBuf);
  Reg.SI := Ofs(InpBuf);
  Reg.ES := Seg(OutBuf);
  Reg.DI := Ofs(OutBuf);
  MsDos(Reg);
  Result := OutBuf.List;                                         { vsledok }
end;

procedure SendMessageToUsername(UserName, Message: String;
                                              var Result: Integer);
{ posiela sprvu uivateovi poda jeho mena }
var
  UserId, HexId, DatTim: String;
  I, ConnType, Res: Integer;

begin
  Result := 1;             { Result = 0 -> Ok ,  1 -> uvae nie je prihl.}
  For I := 1 to Length(UserName) do
    UserName[I] := UpCase(UserName[I]);                { konverzia na vek }
  For I := 1 to UserMax do                      { prejdi monch uvaeov }
  begin
    GetConnectionInfo(I, UserId, HexId, ConnType, DatTim, Res);
    if UserId = UserName then                            { ak je prihlsen }
    begin
      SendMessageToStation(I, Message, Res);   { poli sprvu na jeho slo }
      Result := 0;                                              { vetko OK }
    end;
  end;
end; 

Procedure UserList;
{ vype zoznam prihlsench uvaeov siete (obdoba USERLIST) }
var
  StAll, ConnType, R: Integer;
  UserName, RealName: String;
  NetAddr, StAddr, SocketNum, DateTimeLog, UserHexId: String;

begin
  Writeln('Spojenie Uv. meno    Skuton meno           as prihlsenia   '+
          'Stanica');
  Writeln('-----------------------------------------------------------------'+
          '-----------');
  For StAll := 1 to UserMax do                  { prejdi monch uvaeov }
  begin
    GetInternetAddress(StAll, NetAddr, StAddr, SocketNum, R);
    GetConnectionInfo(StAll, UserName, UserHexID, ConnType, DateTimeLog, R);
    GetRealName(UserName, RealName, R);
    If R = 0 then                           { ak je prihlsen tak ho vyp }
    begin
      If StAll <> Station then
        Writeln(StAll:4,'     ',FStr(UserName,14,' '),
                FStr(RealName,24,' '),DateTimeLog,'   ',StAddr:10)
      else
        Writeln('*',StAll:3,'     ',FStr(UserName,14,' '),
                FStr(RealName,24,' '),DateTimeLog,'   ',StAddr:10);
    end;
  end;
end;

Procedure Info;
{ vype informcii o sieti a OS }
var
  ConnType, R: Integer;
  UserName, RealName, Typ: String;
  NetAddr, StAddr, SocketNum, DateTimeLog, UserHexId: String;
begin
  GetInternetAddress(Station, NetAddr, StAddr, SocketNum, R);
  GetConnectionInfo(Station, UserName, UserHexID, ConnType, DateTimeLog, R);
  GetRealName(UserName, RealName, R);
  GetOSInfo(OSName);
  Case ConnType of
    1: Typ := 'USER';
    2: Typ := 'GROUP';
    3: Typ := 'PRINT SERVER';
    else Typ := '';
  end;
  {}
  Writeln;
  Writeln('Informcie o pripojen:');
  Writeln('------------------------');
  Writeln('slo stanice pripojenia: ',StAddr);
  Writeln('slo pripojenia: ',Station);
  Writeln('Dtum a as pripojenia: ',DateTimeLog);
  Writeln('Uivatesk meno: ',UserName);
  Writeln('Typ uvatea: ',Typ);
  Writeln('ID uvatea: ',UserHexID);
  Writeln('Skuton meno uvatea: ',RealName);
  Writeln;
  Writeln('Server:');
  Writeln('------------------------');
  Writeln('slo serveru: ',NetAddr);
  Writeln('Meno serveru: ',ServerName);               
  Writeln('Maximlny poet uvateov: ',UserMax);    
  Writeln;
  Writeln('Operan systm serveru:');
  Writeln('------------------------');
  Writeln(OSName);                                  
end;

Procedure Help;
{ pri nesprvnom zadan parametrov vype na obrazovku }
begin
  Writeln('Funkcie USERLIST a SEND pre sieov OS Novell NetWare 3.xx (2.xx).');
  Writeln;
  Writeln('Syntax: NETTOOLS <prepna> <param2> <param3>...<paramXX>');
  Writeln;
  Writeln('<Prepna>');
  Writeln('  /L  -vype zoznam uvaeov prihlsench v sieti');
  Writeln('  /S  -posiela sprvu uvaeovi poda jeho uvaeskho mena');
  Writeln('       <param2>             -uvaesk meno');
  Writeln('       <param3>...<paramXX> -sprva');
  Writeln('  /I  -Informcie o sieti a sieovom OS a pripojen');
  Writeln;
  Writeln('Prklady:');
  Writeln('  NETTOOLS /L');
  Writeln('    -vype vetkch uvaeov prihlsench na sieti');
  Writeln('  NETTOOLS /S NOVAK Ako sa m Novk ?');
  Writeln('    -pole sprvu uvaeovi z uvaeskm menom NOVAK');
end;

Function GetParam: Boolean;
{ kontroluje sprvnos parametrov a zisuje z nich informcie }
var I: Integer;
begin
  GetParam := True;
  SMessage := '';
  If (ParamStr(1) = '/L') or (ParamStr(1) = '/l') then
    Func := 1                                         { zoznam prihlsench }
  else
    If (ParamStr(1) = '/S') or (ParamStr(1) = '/s') then
    begin                                           { odkaz }
      If ParamCount < 3 then GetParam := False;     { ak je mlo parametrov }
      Func := 2;
      SUserName := ParamStr(2);
      For I := 3 to ParamCount do                { zlo sprvu z parametrov }
        SMessage := SMessage+' '+ParamStr(I);
    end else
      If (ParamStr(1) = '/I') or (ParamStr(1) = '/i') then
        Func := 3                                              { informcie }
      else GetParam := False;                               { zl parametre }
end;

begin
  Writeln;
  Writeln('NetTools v1.0 (c) 1995');
  GetConection(Station);                           { zisti slo pripojenia }
  If Station = 0 then                         { ak nie je stanica pripojen }
  begin
    Writeln;
    Writeln('Nie ste prihlsen v sieti Novel NetWare !');
    Writeln('Konm...');
    Exit;                                                      { tak skon }
  end;
  GetServerInfo(ServerName, UserMax);               { zisti max. uvateov }
  If (ParamCount < 1) or (ParamStr(1) = '/?') or (Not GetParam) then
  begin
    Help;                                  { pri chybnom zadan vyp pomoc }
    Exit;                                                        { a skoni }
  end;
  Case Func of                                { ktor funkcia sa m vykona }
    1: Userlist;
    2: begin
         SendMessageToUsername(SUserName, SMessage, Result);
         If Result <> 0 then Writeln('Chyba pri posielan sprvy !');
       end;
    3: Info;
  end;
end.